
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Task_dependenciesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const task_dependencies = await db.task_dependencies.create(
            {
                id: data.id || undefined,
        
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await task_dependencies.setTenant( data.tenant || null, {
            transaction,
        });
        
        await task_dependencies.setTask( data.task || null, {
            transaction,
        });
        
        await task_dependencies.setDepends_on_task( data.depends_on_task || null, {
            transaction,
        });
        
        await task_dependencies.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return task_dependencies;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const task_dependenciesData = data.map((item, index) => ({
                id: item.id || undefined,
                
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const task_dependencies = await db.task_dependencies.bulkCreate(task_dependenciesData, { transaction });

        // For each item created, replace relation files
        

        return task_dependencies;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const task_dependencies = await db.task_dependencies.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        updatePayload.updatedById = currentUser.id;

        await task_dependencies.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await task_dependencies.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.task !== undefined) {
            await task_dependencies.setTask(
              
              data.task,
              
              { transaction }
            );
        }
        
        if (data.depends_on_task !== undefined) {
            await task_dependencies.setDepends_on_task(
              
              data.depends_on_task,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await task_dependencies.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return task_dependencies;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const task_dependencies = await db.task_dependencies.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        if (task_dependencies.length !== ids.length) {
            const error = new Error('One or more items were not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await db.sequelize.transaction(async (transaction) => {
            for (const record of task_dependencies) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of task_dependencies) {
                await record.destroy({transaction});
            }
        });


        return task_dependencies;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const task_dependencies = await db.task_dependencies.findByPk(id, options);

        if (!task_dependencies) {
            const error = new Error('Item not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await task_dependencies.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await task_dependencies.destroy({
            transaction
        });

        return task_dependencies;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const task_dependencies = await db.task_dependencies.findOne(
            { where },
            { transaction },
        );

        if (!task_dependencies) {
            return task_dependencies;
        }

        const output = task_dependencies.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await task_dependencies.getTenant({
            transaction
        });
        
        
        output.task = await task_dependencies.getTask({
            transaction
        });
        
        
        output.depends_on_task = await task_dependencies.getDepends_on_task({
            transaction
        });
        
        
        output.organizations = await task_dependencies.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tasks,
        as: 'task',
        
        where: filter.task ? {
          [Op.or]: [
            { id: { [Op.in]: filter.task.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.task.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tasks,
        as: 'depends_on_task',
        
        where: filter.depends_on_task ? {
          [Op.or]: [
            { id: { [Op.in]: filter.depends_on_task.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.depends_on_task.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.task_dependencies.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationsId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'task_dependencies',
                        'task',
                        query,
                    ),
                ],
            };
        }

        const records = await db.task_dependencies.findAll({
            attributes: [ 'id', 'task' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['task', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.task,
        }));
    }

    
};

